Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk.F90	(revision 13719)
@@ -62,5 +62,5 @@
    USE prtctl         ! Print control
 
-   USE sbc_phy        ! a catalog of functions for physical/meteorological parameters in the marine boundary layer, rho_air, q_sat, etc...
+   USE sbc_phy        ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
 
 
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_andreas.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_andreas.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_andreas.F90	(revision 13719)
@@ -35,5 +35,5 @@
    USE dom_oce         ! ocean space and time domain
    USE phycst          ! physical constants
-   USE sbc_phy         ! all thermodynamics functions, rho_air, q_sat, etc... !LB
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
 
    IMPLICIT NONE
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_coare3p0.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_coare3p0.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_coare3p0.F90	(revision 13719)
@@ -37,5 +37,5 @@
 
    USE sbc_oce         ! Surface boundary condition: ocean fields
-   USE sbc_phy         ! all thermodynamics functions, rho_air, q_sat, etc... !LB
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
    USE sbcblk_skin_coare ! cool-skin/warm layer scheme (CSWL_ECMWF) !LB
 
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_coare3p6.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_coare3p6.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_coare3p6.F90	(revision 13719)
@@ -27,5 +27,5 @@
    USE lib_mpp,        ONLY: ctl_stop         ! distribued memory computing library
    USE in_out_manager, ONLY: nit000  ! I/O manager
-   USE sbc_phy         ! all thermodynamics functions, rho_air, q_sat, etc... !LB
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
    USE sbcblk_skin_coare ! cool-skin/warm layer scheme (CSWL_ECMWF) !LB
 
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ecmwf.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ecmwf.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ecmwf.F90	(revision 13719)
@@ -28,5 +28,5 @@
    USE lib_mpp,        ONLY: ctl_stop         ! distribued memory computing library
    USE in_out_manager, ONLY: nit000  ! I/O manager
-   USE sbc_phy         ! all thermodynamics functions, rho_air, q_sat, etc... !LB
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
    USE sbcblk_skin_ecmwf ! cool-skin/warm layer scheme !LB
 
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ice_cdn.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ice_cdn.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ice_cdn.F90	(revision 13719)
@@ -15,5 +15,5 @@
    USE par_oce, ONLY: jpi, jpj, Nis0, Nie0, Njs0, Nje0, nn_hls
    USE phycst          ! physical constants
-   USE sbc_phy         ! all thermodynamics functions, rho_air, q_sat, etc... !LB
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
 
    IMPLICIT NONE
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ice_lg15.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ice_lg15.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ice_lg15.F90	(revision 13719)
@@ -23,5 +23,5 @@
    USE par_oce,  ONLY: jpi, jpj
    USE phycst          ! physical constants
-   USE sbc_phy         ! all thermodynamics functions, rho_air, q_sat, etc... !LB
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
    USE sbcblk_algo_ice_cdn
 
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ice_lu12.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ice_lu12.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ice_lu12.F90	(revision 13719)
@@ -22,5 +22,5 @@
    USE par_oce,  ONLY: jpi, jpj
    USE phycst          ! physical constants
-   USE sbc_phy         ! all thermodynamics functions, rho_air, q_sat, etc... !LB
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
    USE sbcblk_algo_ice_cdn
 
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ncar.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ncar.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_algo_ncar.F90	(revision 13719)
@@ -27,5 +27,5 @@
    USE sbcwave, ONLY: cdn_wave ! wave module
    USE phycst          ! physical constants
-   USE sbc_phy         ! all thermodynamics functions, rho_air, q_sat, etc... !LB
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
 
    IMPLICIT NONE
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_skin_coare.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_skin_coare.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_skin_coare.F90	(revision 13719)
@@ -20,5 +20,5 @@
    USE sbc_oce         ! Surface boundary condition: ocean fields
 
-   USE sbc_phy         ! misc. functions for marine ABL physics (rho_air, q_sat, bulk_formula, etc)
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
 
    USE sbcdcy          !#LB: to know hour of dawn and dusk: rdawn_dcy and rdusk_dcy (needed in WL_COARE)
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_skin_ecmwf.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 13655)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 13719)
@@ -35,5 +35,5 @@
    USE sbc_oce         ! Surface boundary condition: ocean fields
 
-   USE sbc_phy         ! misc. functions for marine ABL physics (rho_air, q_sat, bulk_formula, etc)
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
 
    USE lib_mpp         ! distribued memory computing library