Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/BENCH/MY_SRC/usrdef_istate.F90
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/BENCH/MY_SRC/usrdef_istate.F90	(revision 13761)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/BENCH/MY_SRC/usrdef_istate.F90	(revision 13762)
@@ -27,4 +27,5 @@
 
    PUBLIC   usr_def_istate   ! called by istate.F90
+   PUBLIC   usr_def_ssh      ! called by domqco.F90
 
    !! * Substitutions
@@ -102,4 +103,25 @@
    END SUBROUTINE usr_def_istate
 
+
+   SUBROUTINE usr_def_ssh( ptmask, pssh )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE usr_def_ssh  ***
+      !! 
+      !! ** Purpose :   Initialization of ssh
+      !!                Here BENCH configuration 
+      !!
+      !! ** Method  :   Set ssh
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(in   ) ::   ptmask  ! t-point ocean mask   [m]
+      REAL(wp), DIMENSION(jpi,jpj)         , INTENT(  out) ::   pssh    ! sea-surface height   [m]
+      !!----------------------------------------------------------------------
+      !
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'usr_def_ssh : BENCH configuration, analytical definition of initial state'
+      !
+      pssh(:,:)   = 0._wp  
+      !
+   END SUBROUTINE usr_def_ssh
+   
    !!======================================================================
 END MODULE usrdef_istate
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/ISOMIP/MY_SRC/usrdef_istate.F90
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/ISOMIP/MY_SRC/usrdef_istate.F90	(revision 13761)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/ISOMIP/MY_SRC/usrdef_istate.F90	(revision 13762)
@@ -25,4 +25,5 @@
 
    PUBLIC   usr_def_istate   ! called by istate.F90
+   PUBLIC   usr_def_ssh      ! called by domqco.F90
 
    !!----------------------------------------------------------------------
@@ -66,4 +67,25 @@
    END SUBROUTINE usr_def_istate
 
+
+   SUBROUTINE usr_def_ssh( ptmask, pssh )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE usr_def_ssh  ***
+      !! 
+      !! ** Purpose :   Initialization of ssh
+      !!                Here ISOMIP configuration 
+      !!
+      !! ** Method  :   set ssh
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(in   ) ::   ptmask  ! t-point ocean mask   [m]
+      REAL(wp), DIMENSION(jpi,jpj)         , INTENT(  out) ::   pssh    ! sea-surface height   [m]
+      !!----------------------------------------------------------------------
+      !
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'usr_def_ssh : ISOMIP configuration, analytical definition of initial state'
+      !
+      pssh(:,:)   = 0._wp
+      !
+   END SUBROUTINE usr_def_ssh
+
    !!======================================================================
 END MODULE usrdef_istate
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/LOCK_EXCHANGE/MY_SRC/usrdef_istate.F90
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/LOCK_EXCHANGE/MY_SRC/usrdef_istate.F90	(revision 13761)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/LOCK_EXCHANGE/MY_SRC/usrdef_istate.F90	(revision 13762)
@@ -24,4 +24,5 @@
 
    PUBLIC   usr_def_istate   ! called by istate.F90
+   PUBLIC   usr_def_ssh      ! called by domqco.F90
 
    !!----------------------------------------------------------------------
@@ -78,4 +79,25 @@
    END SUBROUTINE usr_def_istate
 
+
+   SUBROUTINE usr_def_ssh( ptmask, pssh )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE usr_def_ssh  ***
+      !! 
+      !! ** Purpose :   Initialization of ssh
+      !!                Here LOCK_EXCHANGE configuration 
+      !!
+      !! ** Method  :   set ssh
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(in   ) ::   ptmask  ! t-point ocean mask   [m]
+      REAL(wp), DIMENSION(jpi,jpj)         , INTENT(  out) ::   pssh    ! sea-surface height   [m]
+      !!----------------------------------------------------------------------
+      !
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'usr_def_ssh : LOCK_EXCHANGE configuration, analytical definition of initial state'
+      !
+      pssh(:,:)   = 0._wp
+      !
+   END SUBROUTINE usr_def_ssh
+
    !!======================================================================
 END MODULE usrdef_istate
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/MY_SRC/usrdef_istate.F90
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/MY_SRC/usrdef_istate.F90	(revision 13761)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/OVERFLOW/MY_SRC/usrdef_istate.F90	(revision 13762)
@@ -24,5 +24,6 @@
 
    PUBLIC   usr_def_istate   ! called by istate.F90
-
+   PUBLIC   usr_def_ssh      ! called by domqco.F90
+   
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
@@ -78,4 +79,25 @@
    END SUBROUTINE usr_def_istate
 
+
+   SUBROUTINE usr_def_ssh( ptmask, pssh )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE usr_def_ssh  ***
+      !! 
+      !! ** Purpose :   Initialization of the ssh
+      !!                Here  OVERFLOW configuration 
+      !!
+      !! ** Method  :   set ssh
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(in   ) ::   ptmask  ! t-point ocean mask   [m]
+      REAL(wp), DIMENSION(jpi,jpj)         , INTENT(  out) ::   pssh    ! sea-surface height   [m]
+      !!----------------------------------------------------------------------
+      !
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'usr_def_ssh : OVERFLOW configuration, analytical definition of initial state'
+      !
+      pssh(:,:)   = 0._wp
+      !
+   END SUBROUTINE usr_def_ssh
+
    !!======================================================================
 END MODULE usrdef_istate
Index: NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/SWG/MY_SRC/usrdef_istate.F90
===================================================================
--- NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/SWG/MY_SRC/usrdef_istate.F90	(revision 13761)
+++ NEMO/branches/2020/dev_r13327_KERNEL-06_2_techene_e3/tests/SWG/MY_SRC/usrdef_istate.F90	(revision 13762)
@@ -24,4 +24,5 @@
 
    PUBLIC   usr_def_istate   ! called in istate.F90
+   PUBLIC   usr_def_ssh      ! called by domqco.F90
 
    !!----------------------------------------------------------------------
@@ -67,4 +68,25 @@
    END SUBROUTINE usr_def_istate
 
+
+   SUBROUTINE usr_def_ssh( ptmask, pssh )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE usr_def_ssh  ***
+      !! 
+      !! ** Purpose :   Initialization of ssh
+      !!                Here SWG configuration 
+      !!
+      !! ** Method  :   set ssh
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(in   ) ::   ptmask  ! t-point ocean mask             [m]
+      REAL(wp), DIMENSION(jpi,jpj)         , INTENT(  out) ::   pssh    ! sea-surface height
+      !!----------------------------------------------------------------------
+      !
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'usr_def_ssh : SWG configuration, analytical definition of initial state'
+      !
+      pssh(:,:)   = 0._wp        ! ocean at rest
+      !
+   END SUBROUTINE usr_def_ssh
+
    !!======================================================================
 END MODULE usrdef_istate